#!c:/perl/bin/perl

##############################################################################
# MTVWebdesign Logness                        Version 1.0
# arch.cgi: The main script
# Copyright 1999-2000 Maarten Veerman mtveerman@mindless.com
# MTVWebdesign:    http://mtvwebdesign.hypermart.net/ (http://mtvwebdesign.hypermart.net/scripts/)
##############################################################################
# COPYRIGHT NOTICE
# Copyright 1999-2000 Maarten Veerman  All Rights Reserved.
#
# LogNess may be used and modified so long as this
# copyright notice and the comments above remain intact.  By using this
# code you agree to indemnify Maarten Veerman from any liability that
# might arise from its use.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  In other words, please ask first before you try and
# make money off of my program in any way.
#
# Obtain permission before redistributing this software over the Internet or
# in any other medium. In all cases copyright and header must remain intact
#
# Please send bug-reports to cgi-bugs@mtvwebdesign.hypermart.net
##############################################################################
#
# Script tested locally:
# Pentium 400Mhz, 128MB RAM, Windows 98, Apache 1.3.4 (win32), Perl, MS Internet Explorer 5.0, Netscape 4.05.
#
##############################################################################
# Please do not remove the following lines:
$scriptname = "LogNess";
$version = "1.0";
##############################################################################


CONFIG:{
	use CGI::Carp qw(fatalsToBrowser);
	require 'logness.conf';
	require $mtvwebdesignlib;
	require $dbunderpath;
	$dbdir = &dbdir_;
	require $dbunder;
}

MAIN:{
	&getinput;
	&GetCookies;
	
	if (lc $FORM{'action'} eq "redirect") {
		&redirect;
	}
	elsif (lc $FORM{'action'} eq "log") {
		&PurgeOldTables;
		&log;
	}
	else {
		&gencode;
	}
	exit;
}

sub gencode {
	$table = &GetTableName("day");
	my($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime($time);
	
	if (!$ENV{'DOCUMENT_URI'} && !$ENV{'REQUEST_URI'}) { die "Cannot run statistics, since ENV{'DOCUMENT_URI'} does not exist. Server configuration error"; }
	$ENV{'DOCUMENT_URI'} = $ENV{'DOCUMENT_URI'} || $ENV{'REQUEST_URI'};
	$ENV{'HTTP_REFERER'} = $ENV{'HTTP_REFERER'} || 0;

	my @part = split(/\?/,$ENV{'DOCUMENT_URI'});
	$ENV{'DOCUMENT_URI'} = $part[0];

	if ($Cookies{'v'}) {
		$rv=1;
	}
	else {
		$rv=0;
	}
	$FORM{'browser'} = $FORM{'browser'} || 0;
	$FORM{'os'} = $FORM{'os'} || 0;
	$FORM{'java'} = $FORM{'java'} || 0;
	if ($Cookies{'v'}) {
		$FORM{'cookies'} = "Y";
	}
	else {
		$FORM{'cookies'} = "N";
	}
	$FORM{'cookies'} = $FORM{'cookies'} || "N";
	$FORM{'screen'} = $FORM{'screen'} || 0;
	$FORM{'pixel'} = $FORM{'pixel'} || 0;
	$ENV{'HTTP_ACCEPT_LANGUAGE'} = $ENV{'HTTP_ACCEPT_LANGUAGE'} || 0;
	$IP = $ENV{'REMOTE_HOST'} || $ENV{'REMOTE_ADDR'} || 0;
	$RB = $ENV{'HTTP_USER_AGENT'} || 0;
	
	&opendb;
	@check = eval(&CreateTable_("$table","ID","doc","referer","rv","browser","realbrowser","os","java","cookies","screen","pixel","language","IP","hour"));
	@check2 = eval(&AddPrimaryKey_("$table","ID"));

	if ($check[0] == 0) {
		&DropTable_("count");
	}
	
	@check = eval(&CreateTable_("count","number"));
	
	if ($check[0] == 0) {
		&InsertIntoTable_("count","1");
		$userid = "1";
		} else {
		@count = &SelectFromTable_("count","AND","number");
		$userid = $count[1];
		$userid++;
		&UpdateTableSet_("count","AND","number=$userid","number|eq|$count[1]");
	}
	
	&InsertIntoTable_("$table","$userid","$ENV{'DOCUMENT_URI'}","$ENV{'HTTP_REFERER'}","$rv","$FORM{'browser'}","$RB","$FORM{'os'}","$FORM{'java'}","$FORM{'cookies'}","$FORM{'screen'}","$FORM{'pixel'}","$ENV{'HTTP_ACCEPT_LANGUAGE'}","$IP","$hour");
	
	&closedb;
	
	
	print "Content-type: text/html\n\n";
	
	print qq~
	<script language="JavaScript">
	var code = " ";
	
	function ss_escape(s) {
		var plus;
		
		s = escape(s);
		while ((plus = s.indexOf("+")) > 0) {
			s = s.substr(0,plus) + "%2B" + s.substr(plus+1,s.length);
		}
		return s;
	}
	
	
	var script = "$script_location";
	
	var appname = navigator.appName;
	if (navigator.userAgent.indexOf("Opera") != -1) appname = "Opera";
	var appversion = parseFloat(navigator.appVersion);
	
	var s = c = k = "";
	var j = "1";
	var o = navigator.platform;
	
	document.cookie = "ssAllowCookie=true";
	var myCookie = "  " + document.cookie + ";";
	k = (myCookie.indexOf(" ssAllowCookie=") >= 0 ? "Y" : "N");
	
	if (appname == "Netscape")  {
		if (appversion >= 4) {
			s = screen.width+'x'+screen.height;
			c = screen.pixelDepth;
		}
	}
	
	if (appname == "Microsoft Internet Explorer") {
		if (appversion >= 4) {
			s = screen.width+'x'+screen.height;
			c = screen.colorDepth;
		}
	}
	
	if (! o) o = "";
	
	code = '<a href="' + script + '?'
	+ 'action=redirect" target="_top">'
	+ '<img src="' + script + '?action=log&t=$table&userid=$userid'
	+ '&screen=' + escape(s) + '&pixel=' + escape(c)
	+ '&os=' + escape(o)
	+ '&browser=' + ss_escape(appname + ' ' + appversion)
	+ '&java=' + j + '&cookies=' + k
	+ '" border=0></a>';
	
	document.write(code);
	</script>
	<noscript>
	<a href="$script_location?action=redirect" target="_top">
	<img src="$script_location?action=log&old=1" border=0>
	</a>
	</noscript>
	~;
	
}

sub redirect {
	print "Location: http://mtvwebdesign.hypermart.net/scripts/\n\n";
	exit;
}

sub PurgeOldTables {
	# We purge old tables here....
	
	$num_days_log++;
	$num_months_log++;
	
	my($old_table, $old_month_table);
	$old_table = &GetTableName("day","$num_days_log");
	$old_month_table = &GetTableName("month","$num_days_log");
	
	&opendb;
	&DropTable_("$old_table");
	&DropTable_("$old_month_table");
	&closedb;
	
	# Please note:
	# There is no use in checking if the table is actually deleted. You either get
	# 0: Table deleted
	# 1: Table does not exist
	# 3: Foreign key violations.
	# We do not use foreign keys in this script so that
	# leaves that one out.
	# Since we drop the tables every time, we'll recieve the "1"
	# very often. But sometimes we'll receive 0. And than what?
	# Say: Error: Table succesfully deleted? Come on....
	
}

sub log {
	# Log the user!
	
	if (!$FORM{'old'}) {
		$FORM{'browser'} = $FORM{'browser'} || 0;
		$FORM{'os'} = $FORM{'os'} || 0;
		$FORM{'java'} = $FORM{'java'} || 0;
		$FORM{'cookies'} = $FORM{'cookies'} || "N";
		$FORM{'screen'} = $FORM{'screen'} || 0;
		$FORM{'pixel'} = $FORM{'pixel'} || 0;
	}
	
	if ($Cookies{'v'}) {
		$rv=1;
		}else {
		$rv=0;
	}
	
	$table = $FORM{'t'};
	$monthtable = &GetTableName("month");
	
	&opendb;
	
	if ($table && $FORM{'userid'}) {
		@checkme = eval(&BinaryUpdate_("$table","$FORM{'userid'}","rv=$rv|browser=$FORM{'browser'}|os=$FORM{'os'}|java=$FORM{'java'}|cookies=$FORM{'cookies'}|screen=$FORM{'screen'}|pixel=$FORM{'pixel'}"));
	}

	@check = eval(&CreateTable_("$monthtable","day","hits","visitors"));
	
	my($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime($time);
	
	if ($check[0] == 0) {
		&InsertIntoTable_("$monthtable","$mday","1","1");
		} else {
		@count = &SelectFromTable_("$monthtable","AND","hits,visitors","day|eq|$mday");
	}
	if (scalar @count > 1) {
		($hits,$visitors) = split(/\/,$count[1]);
		$hits++;
		$visitors++ unless ($rv == 1);
		&UpdateTableSet_("$monthtable","AND","hits=$hits|visitors=$visitors","day|eq|$mday");
	}
	else {
		&InsertIntoTable_("$monthtable","$mday","1","1");
	}
	
	&closedb;
	
	
	$Cookie_Exp_Date = &MakeDate;
	&SetCookies("v","1");
	print "Location: $logo\n\n";
}

sub GetTableName {
	# Returns the table name, either a day or a month
	
	local($what,$when) = @_;
	
	my($time, $table);
	
	my(@MON)=qw/Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec/;
	my(@WDAY) = qw/Sun Mon Tue Wed Thu Fri Sat/;
	
	if ($when) {
		if ($what eq "day") {
			$when = $when * 24 * 60 * 60;
		}
		elsif ($what eq "month") {
			$when = $when * 31 * 24 * 60 * 60;
		}
		else {
			$table = "Please specify day or month";
			die "$table";
		}
	}
	else {
		$when = 0;
	}
	
	$time = time - $when;
	my($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime($time);
	$year += 1900;
	
	if ($what eq "day") {
		$table = $WDAY[$wday] . $mday . $MON[$mon] . $year;
		return $table;
	}
	elsif ($what eq "month") {
		$table = $MON[$mon] . $year;
		return $table;
	}
	else {
		$table = "Please specify day or month";
		die "$table";
	}
}

sub MakeDate {
	# Sun, 12-Mar-2000 00:00:00 GMT
	
	my(@MON)=qw/Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec/;
	my(@WDAY) = qw/Sun Mon Tue Wed Thu Fri Sat/;
	
	$one_day = 24 * 60 * 60;
	$time = time + $one_day;
	my($sec,$min,$hour,$mday,$mon,$year,$wday) = gmtime($time);
	
	$hour = $min = $sec = "00";
	$year += 1900;
	return sprintf("%s, %02d$sc%s$sc%04d %02d:%02d:%02d GMT",
	$WDAY[$wday],$mday,$MON[$mon],$year,$hour,$min,$sec);
	
}

sub opendb {
	&LockAndOpen_("","LogNess");
	&CreateDatabase_;
}

sub closedb {
	&UnlockAndCommit_;
}
